//+------------------------------------------------------------------+
//|                  Linear regression value  - time series forecast |
//|                                Linear regression value - tsf.mq4 |
//|                                                           mladen |
//|                                                                  |
//|                                                                  |
//| when LRVForecast set to 0   == Linear regression value           |
//| when LRVForecast set to < 0 => future                            |
//| when LRVForecast set to > 0 => past                              |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property  indicator_buffers   1
#property  indicator_color1    Red

//
//
//
//
//

extern int    LRVPeriod   = 20;
extern int    LRVForecast = 0;
extern int    LRVPrice    = PRICE_CLOSE;
double        buffer[];



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer);
   IndicatorShortName("Linear regression value - tsf ("+LRVPeriod+","+LRVForecast+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           limit=MathMin(limit,Bars-LRVPeriod);

   //
   //
   //
   //
   //
   
   double sumXSqr = LRVPeriod * (LRVPeriod-1) * (2*LRVPeriod-1) / 6.0;
   double sumX    = LRVPeriod * (LRVPeriod-1) * 0.5;
      for(i=limit; i>=0; i--)
      {
         double sumXY   = 0;
         double sumY    = 0;

         //
         //
         //
         //
         //

         for (int k=0; k<LRVPeriod; k++)
         {
            double price = iMA(NULL,0,1,0,MODE_SMA,LRVPrice,i+k);
                  sumXY += k*price;
                  sumY  +=   price;
         }
         double slope;
         double divisor  = sumX*sumX - LRVPeriod*sumXSqr;
            if( divisor != 0 ) 
               	slope = (LRVPeriod*sumXY - sumX*sumY)/divisor;
            else  slope = 0; 
   
         //
         //
         //
         //
         //
   
         double intercept = (sumY - slope*sumX) / LRVPeriod ;
         buffer[i] = intercept  + slope * (LRVPeriod-1-LRVForecast);
      }   
   return(0);
}